"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getValues = exports.lookupValue = exports.createEnum = void 0;
function createEnum(value) {
    return Object.freeze(value);
}
exports.createEnum = createEnum;
function lookupValue(_enum, value, defaultValue, ignoreCase = false) {
    const enumValues = Object.values(_enum);
    if (typeof value === 'string' && ignoreCase) {
        const lowerValue = value.toLowerCase();
        const result = enumValues.find((enumValue) => {
            return typeof enumValue === 'string' && enumValue.toLowerCase() === lowerValue;
        });
        return result || defaultValue;
    }
    else {
        const index = enumValues.indexOf(value);
        if (index >= 0) {
            return enumValues[index];
        }
        else {
            return defaultValue;
        }
    }
}
exports.lookupValue = lookupValue;
function getValues(_enum) {
    return Object.values(_enum);
}
exports.getValues = getValues;
//# sourceMappingURL=Enum.js.map