"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRequest = exports.wait = void 0;
const timers = require("timers");
const http_1 = require("http");
const net_1 = require("net");
function wait(time) {
    return new Promise((resolve) => {
        timers.setTimeout(resolve, time);
    });
}
exports.wait = wait;
function createRequest(requestInfo = {}) {
    const socket = new net_1.Socket();
    const request = new http_1.IncomingMessage(socket);
    Object.entries(Object.assign({ method: 'get' }, requestInfo)).forEach(([key, value]) => {
        request[key] = value;
    });
    const response = new http_1.ServerResponse(request);
    return [request, response];
}
exports.createRequest = createRequest;
//# sourceMappingURL=TestUtil.js.map